﻿Type=Class
Version=3.82
B4A=true
@EndOfDesignText@
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::: VT RATING BAR :::::::::::::::::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
'::::::::::::::::::::: BROUGHT TO YOU BY FUSSELDIEB :::::::::::::::::::
'::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

'Class module
Private Sub Class_Globals
	Private StarBar As Panel
	Private FillBar As Panel
	
	Private EventName1 As String
	Private AStar As Int
    Private LastStar As Int
	
	
	Private Starmap As Bitmap
	Private Staractive As Bitmap
	Private Ena As Boolean=True
	
	Private Sli As Boolean=True
	Private AlrSli As Boolean
	Private TP As Panel
	Private Per As Int
	
	Private HS As Boolean
End Sub

'The original size (Bitmap Size) of the RatingBar is 715x130.
'When the parameter 'SizePercent' is set to '100', the RatingBar will be the size of 715x130.
'If the parameter 'SizePercent' is set to '50', the RatingBar will be the size of 358x65 (Half size). And so on...
'<b>The 'Width' and the 'Height' of the panel are automatically adjusted based on the 'SizePercent' value</b>.
'The Event name is used to Raise the 'Rated' Event. Call it e.g. with: <i>'RatingBar1_Rated'</i>
'
'<u>Example code:</u>
'<code>Dim Panel1 As Panel</code>
'<code>Panel1.Initialize("")</code>
'<code>Activity.AddView(Panel1,0,0,0,0)</code>
'<code>RatingBar1.Initialize(30,Panel1,"RatingBar1", False)</code>
Public Sub Initialize(SizePercent As Int, TargetPanel As Panel, EventName As String)
TP=TargetPanel
Per=SizePercent
EventName1=EventName
Dim WidthP As Int
Dim HeightP As Int

WidthP=(715dip / 100)*SizePercent
HeightP=(130dip / 100)*SizePercent

TargetPanel.SetLayout(0,0,WidthP,HeightP)

	StarBar.Initialize("Starbar")
	StarBar.SetBackgroundImage(LoadBitmap(File.DirAssets,"Bar1B.png"))
	TargetPanel.AddView(StarBar,0,0,WidthP,HeightP)
	
	FillBar.Initialize("FillBar")
	FillBar.Color=Colors.RGB(51,181,229)
	TargetPanel.AddView(FillBar,0,0,0,HeightP)
	StarBar.BringToFront
	FillBar.SendToBack
	
End Sub

'Forces the size of the RatingBar. May result on a distorted RatingBar.
'<b>Please Do Not use this method, unless you need it critically!</b>
'Really! Think twice or trice before using this method.
Sub ForceSize(Width As Int,Height As Int)
StarBar.SetLayout(0,0,Width,Height)
FillBar.SetLayout(0,0,Width,Height)
TP.SetLayout(TP.Left,TP.Top,Width,Height)
End Sub

Private Sub WidthPercent(Percentage As Int)
	Return ((StarBar.Width / 100) * Percentage)
End Sub

'Here you can set your own bitmaps for use with the RatingBar. <b>(Not necessary. If you want, you can jump this code.)</b>
'You can change the stars itself, the stars when light up (When pressed)
'and the fill color of the stars when being filled.
'
'<u>Exmple code:</u>
'<code>RatingBar1.Bitmaps(LoadBitmap(File.DirAssets,"Bar1B.png"),LoadBitmap(File.DirAssets,"Bar3B.png"),Colors.RGB(51,181,229))</code>
Sub Bitmaps(Stars As Bitmap, StarsActive As Bitmap, FillColor As Int)
Starmap=Stars
Staractive=StarsActive
FillBar.Color=FillColor
End Sub

'The width of the RatingBar. Only available <b>after</b> the RatingBar being intialized.
Sub getWidth As Int
    Return StarBar.Width
End Sub

'The percentage of the RatingBar. 100% = 715x130
Sub getPercentageSize As Int
    Return Per
End Sub

'The height of the RatingBar. Only available <b>after</b> the RatingBar being intialized.
Sub getHeight As Int
    Return StarBar.Height
End Sub

'Here you can enable or disable the selecting of the stars.
Sub setEnabled(Enabled As Boolean)
    Ena=Enabled
End Sub

'Here you can allow or deny the sliding through stars.
'Maybe to prevent a mess of called events (Because when the user slides through, various events are called.)
'You can also use 'SelectedStars' to get the stars without making a 'mess'.
Sub setSlidingAllowed(SlidingAllowed As Boolean)
   Sli=SlidingAllowed
End Sub

'With this method you can predefine the stars to show in the RatingBar.
'The range is from 0 to 5.
Sub SetStars(Stars As Int, RaiseEvent As Boolean)
FillBar.Width=WidthPercent((Stars*20))
LastStar=Stars

If RaiseEvent=True Then 
CallSub2(Main,EventName1 & "_Rated", Stars)
End If
End Sub

'Returns you the actual selected stars in the RatingBar.
'If you want to generate a event on each 'sliding trough' of the user, please use 'RatingBar1_Rated'.
Sub SelectedStars(Stars As Int)
Return LastStar=Stars
End Sub

'Shows the RatingBar. Same as 'RatingBar1.Visible = True'
Sub Show
StarBar.Visible=True
FillBar.Visible=True
TP.Visible=True
End Sub

'Hides the RatingBar. Same as 'RatingBar1.Visible = False'
Sub Hide
StarBar.Visible=False
FillBar.Visible=False
TP.Visible=False
End Sub

Sub Visible(Visible1 As Boolean)
StarBar.Visible=Visible1
FillBar.Visible=Visible1
TP.Visible=Visible1
End Sub

Sub IsVisible
If TP.Visible=True Then
Return "True"
Else
Return "False"
End If
End Sub

Sub HalfStars(Half As Boolean)
HS=Half
End Sub

Private Sub StarBar_Touch (Action As Int, X As Float, Y As Float)
If Ena=True Then

AStar=LastStar

Select Case Action
    Case 0
	
	If Sli=True Then
	
	If Staractive.IsInitialized Then
	StarBar.SetBackgroundImage(Staractive)
	Else
	StarBar.SetBackgroundImage(LoadBitmap(File.DirAssets,"Bar3B.png"))
	End If
	
	Else
	
	If Starmap.IsInitialized Then
	StarBar.SetBackgroundImage(Starmap)
	Else
	StarBar.SetBackgroundImage(LoadBitmap(File.DirAssets,"Bar1B.png"))
	End If
	
	End If

	Case 1
	If Starmap.IsInitialized Then
	StarBar.SetBackgroundImage(Starmap)
	Else
	StarBar.SetBackgroundImage(LoadBitmap(File.DirAssets,"Bar1B.png"))
	End If
	AlrSli=False
	Case 2
	
	If Sli=False AND AlrSli=False OR Sli=True Then
	AlrSli=True
	
	If HS=False Then
	If X < WidthPercent(0) Then 
	LastStar=0
	End If
	If X > WidthPercent(0) Then 
	LastStar=1
	End If
	If X > WidthPercent(20) Then 
	LastStar=2
	End If
	If X > WidthPercent(40) Then 
	LastStar=3
	End If
	If X > WidthPercent(60) Then 
	LastStar=4
	End If
	If X > WidthPercent(80) Then 
	LastStar=5
	End If
	
	FillBar.Width=WidthPercent((LastStar*20))	
	
	Else
	
	If X < WidthPercent(0) Then 
	LastStar=0
	End If
	If X > WidthPercent(0) Then 
	LastStar=1
	End If
	If X > WidthPercent(10) Then 
	LastStar=1
	End If
	If X > WidthPercent(20) Then 
	LastStar=2
	End If
	If X > WidthPercent(30) Then 
	LastStar=3
	End If
	If X > WidthPercent(40) Then 
	LastStar=4
	End If
	If X > WidthPercent(50) Then 
	LastStar=5
	End If
	If X > WidthPercent(60) Then 
	LastStar=6
	End If
	If X > WidthPercent(70) Then 
	LastStar=7
	End If
	If X > WidthPercent(80) Then 
	LastStar=8
	End If
	If X > WidthPercent(90) Then 
	LastStar=9
	End If
	If X > WidthPercent(95) Then 
	LastStar=10
	End If
	
	FillBar.Width=WidthPercent((LastStar*10))
	
	End If
	
	End If
	
	End Select
	
	
	
	    If LastStar=AStar Then
	    Else
		CallSub2(Main,EventName1 & "_Rated", LastStar)
		End If
End If
End Sub